/*
      Copyright (C) 1999 Alexandre Courbot.

      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License.
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY.
      See the COPYING file for more details.

*/

#include "includes.h"

void pnm_gotonextline(FILE * file)
{
  char buff;
  do
      {
          fread(&buff,1,1,file);
      }while(buff!='\n');
}

int pnm_checkforcomment(FILE * file)
{
  char buff;
  fread(&buff,1,1,file);
  if(buff=='#') {pnm_gotonextline(file); return(1);}
  else {fseek(file,-1,SEEK_CUR);return(0);}
}

void * read_pnm(FILE * file, short int * lenght, short int * height)
{
  void * image;
  char sign[10];
  int i=0;
  fread(sign,2,1,file);
  if ((sign[0]!='P')||(sign[1]!='6')) {printf("Invalid format.\n");return(NULL);}
  pnm_gotonextline(file);
  /* Getting height and lenght */
  while(pnm_checkforcomment(file));
  do
      {
          fread(&sign[i],1,1,file);
          i++;
      }while(sign[i-1]!=' ');
  sign[i-1]=0;
  *lenght=atoi(sign);
  i=0;
  do
      {
          fread(&sign[i],1,1,file);
          i++;
      }while(sign[i-1]!='\n');
  sign[i-1]=0;
  *height=atoi(sign);
  /* Going to next line */
  pnm_gotonextline(file);
  /* Reading the image */
  image=calloc((*lenght)*(*height),3);
  fread(image,3,(*lenght)*(*height),file);
  return(image);
}

void * load_pnm(char * filename, short int * lenght, short int * height)
{
  void * image=NULL;
  FILE * file;
  /* Check validity */
  file=fopen(filename,"r");
  if(file)
      {
          image=read_pnm(file, lenght, height);
          fclose(file);
      }
  return(image);
}

void put_pnm(FILE * file, void * image, int lenght, int height)
{
  fprintf(file,"P6\n%d %d\n255\n",lenght,height);
  fwrite(image,lenght*height*3,1,file);
}
 
int write_pnm(char * filename, void * image, int lenght, int height)
{
  FILE * file;
  file=fopen(filename,"w"); 
  if(!file) return(1);
  else
      {
          put_pnm(file,image,lenght,height);
          fclose(file);
          return(0);
      }
}

/* Open a pnm file and adapt colors to current depth */
void *  load_pnm_from_file(char*filename, short int * l, short int * h)
{
  void * result=NULL,*temp;
  temp=load_pnm(filename,l,h);
  if(temp)
      {
          result=(void*)calloc((*l)*(*h),bytes_per_pixel);
          adapttodepth(result,temp,(*l)*(*h));
          free (temp);
      }
  return(result);
}


